/*
 * Itsy SA1100 Profiling Applications: Image Hash Header File
 *
 * Copyright (c) Compaq Computer Corporation, 1999
 *
 * Use consistent with the GNU GPL is permitted,
 * provided that this copyright notice is
 * preserved in its entirety in all copies and derived works.
 *
 * COMPAQ COMPUTER CORPORATION MAKES NO WARRANTIES, EXPRESSED OR IMPLIED,
 * AS TO THE USEFULNESS OR CORRECTNESS OF THIS CODE OR ITS
 * FITNESS FOR ANY PARTICULAR PURPOSE.
 *
 */

/*
 * Author: Carl Waldspurger
 *
 * $Log: ihash.h,v $
 * Revision 1.1.1.1  2000/11/28 16:46:34  kerr
 * Compaq Profiling Infrastructure
 *
 * Revision 1.2  1999/08/20  01:24:24  caw
 * Added documentation.
 *
 * Revision 1.1  1999/08/20 01:12:47  caw
 * Initial revision.
 *
 */

#ifndef	_IHASH_H

/*
 * operations
 *
 */

extern int image_file_hash(const char *name, int *hash);
  /*
   * modifies: hash
   * effects:  Sets hash to a hash value computed using header 
   *           information from the named executable image.
   *           Returns SUCCESS or FAILURE.
   *
   */

#endif	/* _IHASH_H */
